Option Explicit

Const msiOpenDatabaseModeReadOnly     = 0
Const msiOpenDatabaseModeTransact     = 1
Const msiOpenDatabaseModeCreate       = 3

Const msiViewModifyInsert         = 1
Const msiViewModifyUpdate         = 2
Const msiViewModifyAssign         = 3
Const msiViewModifyReplace        = 4
Const msiViewModifyDelete         = 6

Const ForAppending = 8
Const ForReading = 1
Const ForWriting = 2
Const TristateTrue = -1

Dim msiInstaller
Dim msiDatabase
Dim msiView
Dim msiRecord

Dim WshShell, oExec

if WScript.Arguments.Count = 0 then
    WScript.Echo "Missing parameters - provide the client exe path"
end if 


Set WshShell = WScript.CreateObject("WScript.Shell")
Dim x: x = WshShell.Run(Wscript.Arguments(0) &"  /extract", 0, true)

Dim sCurPath : sCurPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".")
WScript.Echo sCurPath

Dim databasePath : databasePath = sCurPath & "\" & "FileWaveWinClient.msi"
Dim importPath : importPath = sCurPath & "\" & "disk1.cab"

WScript.Echo databasePath 
WScript.Echo importPath 


' Connect to Windows Installer object
'On Error Resume Next
Dim installer : Set installer = Nothing
Set installer = Wscript.CreateObject("WindowsInstaller.Installer") : CheckError


Dim openMode: openMode  = msiOpenDatabaseModeTransact
Dim updateMode: updateMode = msiViewModifyAssign  'Either insert or replace existing row

Dim streamName
If streamName = Empty And importPath <> Empty Then streamName = Right(importPath, Len(importPath) - InStrRev(importPath, "\",-1,vbTextCompare))

If UCase(importPath) = "/D" Or UCase(importPath) = "-D" Then updateMode = msiViewModifyDelete : importPath = Empty 'Stream will be deleted if no input data

' Open database and create a view on the _Streams table
Dim sqlQuery : Select Case updateMode
    Case msiOpenDatabaseModeReadOnly: sqlQuery = "SELECT `Name` FROM _Streams"
    Case msiViewModifyAssign:         sqlQuery = "SELECT `Name`,`Data` FROM _Streams"
    Case msiViewModifyDelete:         sqlQuery = "SELECT `Name` FROM _Streams WHERE `Name` = ?"
End Select




Dim database : Set database = installer.OpenDatabase(databasePath, openMode) : CheckError
Dim view     : Set view = database.OpenView(sqlQuery)
Dim record

If openMode = msiOpenDatabaseModeReadOnly Then 'If listing streams, simply fetch all records
    Dim message, name
    view.Execute : CheckError
    Do
        Set record = view.Fetch
        If record Is Nothing Then Exit Do
        name = record.StringData(1)
        If message = Empty Then message = name Else message = message & vbNewLine & name
    Loop
    Wscript.Echo message
Else 'If adding a stream, insert a row, else if removing a stream, delete the row
    Set record = installer.CreateRecord(2)
    record.StringData(1) = streamName
    view.Execute record : CheckError
    If importPath <> Empty Then  'Insert stream - copy data into stream
        record.SetStream 2, importPath : CheckError
    Else  'Delete stream, fetch first to provide better error message if missing
        Set record = view.Fetch
        If record Is Nothing Then Wscript.Echo "Stream not present:", streamName : Wscript.Quit 2
    End If
    view.Modify updateMode, record : CheckError
    database.Commit : CheckError
    'Set view = Nothing
    'Set database = Nothing
    CheckError
End If

Dim mediaQry: mediaQry = "SELECT `DiskId`,`LastSequence`,`DiskPrompt`,`Cabinet`,`VolumeLabel`,`Source` FROM Media"
Dim mediaView: set mediaView = database.OpenView(mediaQry)
Dim mediaRecord
mediaView.Execute : CheckError
set mediaRecord = mediaView.Fetch
Dim cabinet
cabinet = mediaRecord.StringData(4)

mediaRecord.StringData(5) = ""
mediaRecord.StringData(4) = "#" & cabinet
mediaRecord.StringData(3) = ""

mediaView.Execute mediaRecord : CheckError
mediaView.Modify updateMode, mediaRecord : CheckError
database.Commit : CheckError

Set database = Nothing
Set view = Nothing
Set mediaView = Nothing


Sub CheckError
    Dim message, errRec
    If Err = 0 Then Exit Sub
    message = Err.Source & " " & Hex(Err) & ": " & Err.Description
    If Not installer Is Nothing Then
        Set errRec = installer.LastErrorRecord
        If Not errRec Is Nothing Then message = message & vbNewLine & errRec.FormatText
    End If
    Wscript.Echo message
    Wscript.Quit 2
End Sub